%global bootstrap 0
%global __os_install_post /usr/lib/rpm/brp-compress %{nil}
%global patchdate 20130415

Summary:        MiNT cross-compiler (GCC) for C.
Name:           m68k-atari-mint-gcc
Version:        4.6.4
Release:        1%{?dist}
License:        GPLv3+ and GPLv3+ with exceptions and GPLv2+ with exceptions
Group:          Development/Languages
URL:            http://gcc.gnu.org
Source0:        http://ftp.gnu.org/pub/gnu/gcc/gcc-%{version}/gcc-%{version}.tar.bz2
Patch0:         http://vincent.riviere.free.fr/soft/m68k-atari-mint/archives/gcc-%{version}-mint-%{patchdate}.patch.bz2

BuildRequires:  m68k-atari-mint-binutils
%if ! 0%{?bootstrap}
BuildRequires:  m68k-atari-mint-mintlib
BuildRequires:  m68k-atari-mint-pml
%endif
BuildRequires:  gmp-devel
BuildRequires:  mpfr-devel
BuildRequires:  libmpc-devel
BuildRequires:  zlib-devel
BuildRequires:  libgomp
BuildRequires:  flex
%if 0%{?fedora} || 0%{?rhel} >= 7
BuildRequires:  ppl-devel
BuildRequires:  cloog-ppl-devel
%endif

Requires:       m68k-atari-mint-binutils
%if ! 0%{?bootstrap}
Requires:       m68k-atari-mint-mintlib
Requires:       m68k-atari-mint-pml
%endif


%description
MiNT cross-compiler (GCC) for C.


%prep
%setup -q -n gcc-%{version}
%patch0 -p1


%build
mkdir -p build
pushd build

export CC="%{__cc} ${RPM_OPT_FLAGS}"
../configure \
    --prefix=%{_prefix} \
    --bindir=%{_bindir} \
    --includedir=%{_includedir} \
    --libdir=%{_libdir} \
    --mandir=%{_mandir} \
    --infodir=%{_infodir} \
    --datadir=%{_datadir} \
    --build=%_build --host=%_host \
    --with-gnu-as --with-gnu-ld --verbose \
    --disable-plugin \
    --with-system-zlib \
    --disable-nls --without-included-gettext \
    --enable-languages="c,c++" \
    --disable-lto \
%if 0%{?fedora}
    --with-ppl --disable-ppl-version-check --with-cloog \
%endif
%if 0%{?bootstrap}
    --with-newlib --without-headers \
%else
    --without-newlib \
%endif
    --target=%{mint_target} \
    --with-sysroot=%{mint_sysroot} \
    --with-gxx-include-dir=%{mint_includedir}/c++ \
    CFLAGS_FOR_TARGET="-O2 -fomit-frame-pointer" \
    CXXFLAGS_FOR_TARGET="-O2 -fomit-frame-pointer"



%if 0%{?bootstrap}
make %{?_smp_mflags} all-gcc all-target-libgcc
%else
make %{?_smp_mflags} all
%endif

popd


%install
pushd build

%if 0%{?bootstrap}
make DESTDIR=$RPM_BUILD_ROOT install-gcc install-target-libgcc
%else
make DESTDIR=$RPM_BUILD_ROOT install
%endif

popd

# fix some things
rm -rf $RPM_BUILD_ROOT%{_infodir}
rm -f $RPM_BUILD_ROOT%{_libdir}/libiberty.a
rm -f $RPM_BUILD_ROOT%{_mandir}/man7/*
rm -rf $RPM_BUILD_ROOT%{_libdir}/gcc/%{mint_target}/%{version}/plugin
rm -rf $RPM_BUILD_ROOT%{_datadir}/gcc-%{version}/python

%if ! 0%{?bootstrap}
mkdir -p $RPM_BUILD_ROOT%{mint_libdir}
mv $RPM_BUILD_ROOT%{_prefix}/%{mint_target}/lib/* $RPM_BUILD_ROOT%{mint_libdir}
%endif

# Don't want the *.la files.
find $RPM_BUILD_ROOT -name '*.la' -delete


%files
%doc
%{_bindir}/%{mint_target}-*
%{_mandir}/man1/%{mint_target}-*.1*
%{_libexecdir}/gcc/%{mint_target}
%{_libdir}/gcc/%{mint_target}
%if ! 0%{?bootstrap}
%{mint_libdir}/*
%{mint_includedir}/c++
%endif


%changelog
* Wed May 14 2014 Dan Horák <dan[at]danny.cz> - 4.6.4-1
- update to 4.6.4

* Mon Mar 26 2012 Dan Horák <dan[at]danny.cz> - 4.6.3-2
- non-bootstrap build

* Sun Mar 25 2012 Dan Horák <dan[at]danny.cz> - 4.6.3-1
- update to 4.6.3

* Thu Aug 04 2011 Dan Horák <dan[at]danny.cz> - 4.5.3-1
- bootstrap enabled
- initial Fedora version
